<!--
  -    Copyright [2021] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row>
    <v-col v-if="applicationStore.session.user.permissions.includes('ADMIN')">
      <v-card>
        <v-card-title class="red--text"> Plausibilitätsüberprüfung für Gruppen </v-card-title>
        <v-card-text>
          <v-alert type="success" v-if="success">
            Gruppendaten wurden erfolgreich re-synchronisiert.
          </v-alert>

          <v-form ref="form" v-if="!success">
            <v-alert type="warning" v-if="error">
              Bitte folgende Fehler beheben:
              <ul>
                <li v-for="e in error" :key="e">
                  {{ e }}
                </li>
              </ul>
            </v-alert>

            <background-job-status
              v-if="!groupDetails && checkGroupJobId"
              :jobId="checkGroupJobId"
              @job_completed="processJobCompleted"
            >
            </background-job-status>

            <v-data-table
              v-if="groupDetails"
              v-model="selected"
              :headers="headers"
              :items="groupDetails"
              item-key="user.id"
              show-select
            >
            </v-data-table>

            <v-checkbox
              v-model="synchronizeGroups.verified"
              :rules="[(v) => !!v || 'Die Zustimmung ist erforderlich']"
              :disabled="sending || !groupDetails || groupDetails.length == 0"
              required
            >
              <template v-slot:label>
                Ja, alle ausgewählten Gruppen sollen re-synchronisiert werden.
              </template>
            </v-checkbox>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="reset"
            v-if="success"
          >
            Weitere Plausibilitätsüberprüfungen durchführen
          </v-btn>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="reset"
            v-if="!success && groupDetails"
          >
            Formular zurücksetzen
          </v-btn>
          <v-spacer />
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="doResynchronizeGroups"
            :loading="sending"
            :disabled="sending || groupDetails.length == 0 || !synchronizeGroups.verified"
            v-if="!success && groupDetails"
            >Openproject resynchronisieren
          </v-btn>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="doRepairGroups"
            :loading="sending"
            :disabled="
              sending ||
              groupDetails.length == 0 ||
              selected.length == 0 ||
              !synchronizeGroups.verified
            "
            v-if="!success && groupDetails"
            >Autoreparatur durchführen
          </v-btn>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="doCheckGroups"
            :loading="sending"
            :disabled="sending"
            v-if="!success && !groupDetails"
            >Gruppen überprüfen
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import * as api from '../../api';
import * as util from "../../util";
import { useApplicationStore } from '../../stores/application';

export default {
  data: () => {
    return {
      sending: false,
      success: false,
      error: null,
      groups: [],
      items: [],
      checkGroups: {
        autoRepair: 'JUST_CHECK',
      },
      synchronizeGroups: {
        verified: false,
      },
      headers: [
        {
          text: 'Name',
          value: 'group.name',
        },
        {
          text: 'Beschreibung',
          value: 'group.description',
        },
        {
          text: 'Basisdaten',
          value: 'generalStatus',
        },
      ],
      checkGroupJobId: null,
      groupDetails: null,
      selected: [],
      applicationStore: useApplicationStore(),
      util,
    };
  },
  methods: {
    reset: function () {
      this.error = null;
      this.synchronizeGroups.verified = false;
      this.sending = false;
      this.success = false;
      this.checkGroupJobId = null;
      this.groupDetails = null;
      this.selected = [];
    },
    doCheckGroups: function () {
      this.$emit('clearError');
      this.sending = true;

      fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/iog/plausibility/checkgroups', {
        method: 'POST',
        credentials: 'include',
        body: JSON.stringify(this.checkGroups),
      })
        .then((response) => {
          if (response.status === 201) {
            response.json().then((data) => {
              this.checkGroupJobId = data.id;
            });
          } else if (response.status === 401) {
            this.$router.push('/logout');
          } else if (response.status === 400) {
            this.sending = false;
            response
              .json()
              .then((data) => {
                console.log(data);
                this.error = data;
              })
              .catch((error) => {
                console.log(error);
                this.$emit('unexpectedError');
              });
          } else {
            this.sending = false;
            this.$emit('unexpectedError');
          }
        })
        .catch((error) => {
          console.log(error);
          this.sending = false;
          this.$emit('networkError');
        });
    },
    convertGroupDetails: function (entry) {
      return Object.assign(entry, {
        isSelectable:
          entry.generalStatus != 'OK' &&
          !entry.generalStatus.includes('manuelle Reparatur erforderlich'),
      });
    },
    processJobCompleted: function (result) {
      if (api.job.isErrorResult(result)) {
        this.error = [result.error];
        this.sending = false;
      } else {
        this.sending = false;
        if (result.overallStatus == 'OK') {
          this.groupDetails = [];
        } else {
          this.groupDetails = result.entries
            .filter((entry) => entry.generalStatus != 'OK')
            .map((entry) => this.convertGroupDetails(entry));
        }
        this.selected = [];
      }
    },
    doResynchronizeGroups: function () {
      if (this.$refs.form.validate() && this.synchronizeGroups.verified) {
        this.$emit('clearError');
        this.sending = true;
        this.groupDetails = null;
        this.checkGroupJobId = null;
        // ignore selection when doing the resync-only job
        const body = Object.assign({}, { autoRepair: 'RESYNC_ONLY' });
        fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/iog/plausibility/checkgroups', {
          method: 'POST',
          credentials: 'include',
          body: JSON.stringify(body),
        })
          .then((response) => {
            if (response.status === 201) {
              response.json().then((data) => {
                this.checkGroupJobId = data.id;
              });
            } else if (response.status === 401) {
              // unauthorized, ask to login  again
              this.$router.push('/logout');
            } else if (response.status === 403) {
              // forbidden, no permissions or wrong password
              this.sending = false;
              this.error = ['Keine Berechtigung oder falsches Passwort'];
            } else if (response.status === 400) {
              this.sending = false;
              response
                .json()
                .then((data) => {
                  this.error = data;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else {
              this.sending = false;
              this.$emit('unexpectedError');
            }
          })
          .catch((error) => {
            console.log(error);
            this.sending = false;
            this.$emit('networkError');
          });
      }
    },
    doRepairGroups: function () {
      if (this.$refs.form.validate() && this.synchronizeGroups.verified) {
        this.$emit('clearError');
        this.sending = true;
        this.checkGroupJobId = null;
        let body = Object.assign({}, this.checkUsers);
        if (this.selected.length == this.userDetails.length) {
          // repair all
          body = Object.assign(body, { autoRepair: 'AUTOREPAIR_ALL' });
        } else {
          // fill autoRepairUserIds with the selected entries
          body = Object.assign(body, {
            autoRepair: 'AUTOREPAIR_SELECTED',
            autoRepairGroupIds: this.selected.map((entry) => entry.user.id),
          });
        }
        this.userDetails = null;
        this.selected = [];
        fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/iog/plausibility/checkgroups', {
          method: 'POST',
          credentials: 'include',
          body: JSON.stringify(body),
        })
          .then((response) => {
            if (response.status === 201) {
              response.json().then((data) => {
                this.checkGroupJobId = data.id;
              });
            } else if (response.status === 401) {
              // unauthorized, ask to login  again
              this.$router.push('/logout');
            } else if (response.status === 403) {
              // forbidden, no permissions or wrong password
              this.sending = false;
              this.error = ['Keine Berechtigung oder falsches Passwort'];
            } else if (response.status === 400) {
              this.sending = false;
              response
                .json()
                .then((data) => {
                  this.error = data;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else {
              this.sending = false;
              this.$emit('unexpectedError');
            }
          })
          .catch((error) => {
            console.log(error);
            this.sending = false;
            this.$emit('networkError');
          });
      }
    },
  },
  beforeUnmount() {
    this.$emit('clearError');
  },
};
</script>

<style scoped></style>
